uniform mat4 SkyMatrix4x4; // vynasobena 

attribute float aTerrain_z;
attribute float aWater_w;

varying vec3 vNormal;
varying vec3 vLight;
varying vec3 vHalfVec;
varying vec4 vDiffuse, vAmbient;
varying vec3 vPos;
varying float vTerrain_z;

void main(void)
{
  // souradnice noise textury
  vPos = gl_Vertex.xyz;
  vTerrain_z=aTerrain_z;

  // souradnice reflect textury
  vec4 WorldPos = SkyMatrix4x4 *  gl_Vertex;	
  vec3 N = normalize(SkyMatrix4x4 * vec4(gl_Normal,0.0)).xyz; 
  vec3 E = normalize(WorldPos.xyz);	
  gl_TexCoord[0].xyz = reflect(E, N); 

  // vypocet barev podle vlastnosti materialu a svetla - zatim se nepocita konkretni osvetleni, jen barvy!
  vDiffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
  vAmbient = gl_FrontMaterial.ambient * (gl_LightSource[0].ambient + gl_LightModel.ambient);

  // vypocet promennych vyuzivanych pro osvetleni ve fragment shaderu
  vec3 Pos = normalize(gl_ModelViewMatrix * gl_Vertex).xyz;
	vLight = normalize(gl_LightSource[0].position).xyz;
  vHalfVec = normalize(gl_LightSource[0].halfVector.xyz);
  vHalfVec = normalize(vHalfVec-normalize(Pos-vLight));
  vNormal = normalize(gl_Normal);
  
  gl_Position = ftransform();		
}
